/**
 * \file cella.cpp
 *    cella objektum a labirintus programhoz.
 * $Id: cella.cpp 499 2015-05-05 10:53:36Z szebi $
 */

#include "memtrace.h"
#include "cella.h"

/**
 * Lábnyom beírása a cellába.
 */
void Cella::SetNyom(int n) {                    // lábnyom beirása
    Labnyom lny(GetObj(), n);                   // lábnyom létrehozása az adott iránnyal
    ny.insert(lny);                             // beírja a halmazba
};

/**
 * Lábnyom kiolvasása a cellából.
 * Adott azonosítójú nyomból kiolvassa az irányt, hogy merről jött.
 */
int Cella::GetNyom(const Obj *a) {              // lábnyom kiolvasása
    nyIter it = ny.find(Labnyom(a));
    if (it != ny.end())
      return(it->errol);                        // talált, erről jött utoljára.
    return(-1);
};
