/**
 * \file obj.h
 *    Obj objektum definiciója a labirintus programhoz.
 * $Id: obj.h 499 2015-05-05 10:53:36Z szebi $
 */

#ifndef OBJ_H
#define OBJ_H

#ifndef NULL
# define NULL 0           // hogy ne kelljen az iostream-et a NULL miatt include-olni
#endif

class Cella;              // elődeklaráció. Azért kell, hogy az ismert legyen mint típus.

/**
 * Alapobjektum .
 */
class Obj {
protected:
    int ir;               ///< ebbe az irányba tart most.
public:
    /// Defaul konstruktor
    Obj() :ir(-1) {};     // kezdő irány

    /// Adott irányba "néz".
    /// Adott irányban levő szomszédos cella objektumának lekérdezése
    /// @param i - irány (J, L, B, F)
    /// @param c - saját cellára mutató referencia
    /// @param b - true, ha visszalépés, ezért önmaga nem számít
    /// @return objektum pointere
    Obj *Nez(int i, Cella &c, bool b = false);  // szomszéd lekérdezése

    /// Adott irámyba lép.
    /// @param i - irány (J, L, B, F)
    /// @param c - saját cellára mutató referencia
    /// @param b - false: normál lépés
    /// @param b - true: visszalépés
    void Lepj(int i, Cella &c, bool b = false); // adott irányba lép egyet

    /// Jel lekérdezése
    virtual char Jele() = 0;                    // lekérdezi a jelét

    /// Erő lekérdezése
    virtual int  Ereje() = 0;                   // lekérdezi az erejét

    /// Cellán levő objektum léptetése
    virtual void Lep(Cella &c);                 // objektumot lépteti eggyel

    /// Függvényhívás operátor
    virtual void operator()(Obj*) {};           // meghívódik ha az objektumot "eltaposták"
};

/**
 * Üres objektum
 */
class Ures :public Obj {
public:
    char Jele() { return('.'); }                // '.'-t ad vissza
    int  Ereje() { return(0); }                 // ures ereje
    void Lep(Cella &c) {}                       // léptet nem lép
};

extern Ures URES;

#endif
